=== requirements.txt ===
# > 60 introduces ImportError: cannot import name 'build_py' from 'setuptools._distutils.command'
# FIXME: Check if fixed in later versions?
setuptools>=59.5,<60; python_version < '3.10'
setuptools>=62.3; python_version >= '3.10'
packaging
build==0.7
sphinx
sphinx-panels
six
wheel>=0.35
PyOpenGL
pyinstaller==3.6
numpy
nuitka
dataclasses; python_version < '3.7'
furo
sphinx-copybutton
distro; sys_platform == 'linux'
