=== examples/external/opencv/requirements.txt ===
opencv-python
